From 0a2d117fbab513788f42fc110c4a624fe7357c02 Mon Sep 17 00:00:00 2001
From: RS <sayrer@gmail.com>
Date: Jan 28 2020 05:47:37 +0000
Subject: [PATCH 17/2232] Emit cxxbridge (#27)


* Working cxxbridge output.

* Add a way to emit cxxbridge.h

---

diff --git a/cmd/src/main.rs b/cmd/src/main.rs
index daa5ac0..96d21a5 100644
--- a/cmd/src/main.rs
+++ b/cmd/src/main.rs
@@ -1,7 +1,8 @@
 mod gen;
 mod syntax;
 
-use std::io::{self, Write};
+use gen::include::get_full_cxxbridge;
+use std::io::{self, Error, ErrorKind, Write};
 use std::path::PathBuf;
 use structopt::StructOpt;
 
@@ -10,20 +11,28 @@ use structopt::StructOpt;
 struct Opt {
     /// Input Rust source file containing #[cxx::bridge]
     #[structopt(parse(from_os_str))]
-    input: PathBuf,
+    input: Option<PathBuf>,
 
-    /// Emit header with declarations only
+    /// Emit header with declarations only. If no input is specified, emit cxxbridge.h
     #[structopt(long)]
     header: bool,
 }
 
-fn main() {
+fn main() -> Result<(), Error> {
     let opt = Opt::from_args();
-    let gen = if opt.header {
-        gen::do_generate_header
+
+    if let Some(input) = opt.input {
+        let gen = if opt.header {
+            gen::do_generate_header
+        } else {
+            gen::do_generate_bridge
+        };
+        let bridge = gen(&input);
+        io::stdout().lock().write_all(bridge.as_ref())
+    } else if opt.header {
+        io::stdout().lock().write_all(get_full_cxxbridge().as_ref())
     } else {
-        gen::do_generate_bridge
-    };
-    let bridge = gen(&opt.input);
-    let _ = io::stdout().lock().write_all(bridge.as_ref());
+        let mut clap = Opt::clap().after_help("");
+        clap.print_help().or(Err(Error::new(ErrorKind::Other, "Failed to write help")))
+    }
 }
diff --git a/gen/include.rs b/gen/include.rs
index 00e67f0..f38ae73 100644
--- a/gen/include.rs
+++ b/gen/include.rs
@@ -11,3 +11,7 @@ pub fn get(guard: &str) -> &'static str {
         panic!("not found in cxxbridge.h header: {}", guard)
     }
 }
+
+pub fn get_full_cxxbridge() -> &'static str {
+    return HEADER
+}

